# Deduplicator
Once we have finished preprocessing all the corpora with our filters we are left with many different files that might contain duplicates. To use the deduplicator you do:
`./dedup.sh ROOT_DIRECTORY_TO_CLEAN_FILES NEW_DIRECTORY_WHERE_ALL_DEDUPPED_FILES_WILL_BE_PLACED`

`dedup.sh` will take care of creating the same directory structure at the target location. The deduplicator also incrementally dumps `shashes.pickle` and `thashes.pickle` so that it keeps track of what lines it has seen so far across different files. The script will delete those files before it runs in order to make sure that you don't run into issues when moving to new languages. Example usage:

```bash
./dedup.sh ../../../CLEAN_ZH/ ../../../CLEAN_ZH_DEDUP
Deduplicating CLEAN/Tatoeba-v2022-03-03.clean.en-zh ...
Deduplicating CLEAN/MultiUN-v1.clean.en-zh ...
Deduplicating CLEAN/TED2013-v1.1.en-zh ...
Deduplicating CLEAN/WMT-News-v2019.clean.en-zh ...
Deduplicating CLEAN/TED2020-v1.clean.en-zh ...
Deduplicating CLEAN/ELRC-3056-wikipedia_health-v1.clean.en-zh ...
Deduplicating CLEAN/News-Commentary-v9.1.clean.en-zh ...
Deduplicating MEDIUM/ELRC_2922-v1.clean.en-zh ...
Deduplicating MEDIUM/WikiMatrix-v1.clean.en-zh ...
Deduplicating MEDIUM/tico-19-v2020-10-28.clean.en-zh ...
Deduplicating MEDIUM/UNPC-v20090831.clean.en-zh ...
Deduplicating MEDIUM/Tanzil-v1.clean.en-zh ...
Deduplicating MEDIUM/bible-uedin-v1.clean.en-zh ...
Deduplicating DIRTY/infopankki-v1.clean.en-zh ...
Deduplicating DIRTY/LinguaTools-WikiTitles-v2014.clean.en-zh ...
Deduplicating DIRTY/CCMatrix.clean.en-zh ...
Deduplicating DIRTY/CCAligned.clean.en-zh ...
Deduplicating DIRTY/OpenSubtitles-v2016.clean.en-zh ...
Deduplicating DIRTY/ParaCrawl-v9.clean.en-zh ...
```

Based on the work of @ZJaume , the deduplicator also takes care of near duplicates that differ only by lower and upper case.
